/**
 * 手写签名板公用js
 */
var url = "ws://192.168.161.128:12343";
url = "ws://127.0.0.1:12351";
////url = "ws://192.168.100.5:12343"
var websocket;
var connected = false;
var maxWidth = 800;
var maxHeight = 480;
var maxPressure = 2048;
function resizeCanvas() {
	var canvas = document.getElementById("pointCanvas");
	// When zoomed out to less than 100%, for some very strange reason,
	// some browsers report devicePixelRatio as less than 1
	// and only part of the canvas is cleared then.
	var ratio = Math.max(window.devicePixelRatio || 1, 1);
	canvas.width = canvas.offsetWidth * ratio;
	canvas.height = canvas.offsetHeight * ratio;
	canvas.getContext("2d").scale(ratio, ratio);
}
window.onresize = resizeCanvas;
resizeCanvas();

var lastPoint = {
	x: "0",
	y: "0",
	pressure: "0"
};

function drawPoint(point) {
	var canvas = document.getElementById("pointCanvas");
	var ctx = canvas.getContext("2d");

	ctx.strokeStyle = "#000000"; //颜色的值
	if (point.pressure != "0" && lastPoint.pressure != "0") { //移动
		x = canvas.width * 1.0 / maxWidth * point.x;
		y = canvas.height * 1.0 / maxHeight * point.y;
		console.log("$$$$$$$$$$$::::w::" + canvas.width + "    h:" + canvas.height + "  x:" + point.x + "   y:" + point
			.y + "  p:" + point.pressure);
		ctx.beginPath();
		ctx.lineCap = "round";
		ctx.lineWidth = Number(point.pressure) * 1.0 / maxPressure * 10 + 1;
		ctx.moveTo(canvas.width * 1.0 / maxWidth * lastPoint.x, canvas.height * 1.0 / maxHeight * lastPoint.y);
		ctx.lineTo(canvas.width * 1.0 / maxWidth * point.x, canvas.height * 1.0 / maxHeight * point.y);
		ctx.stroke();
	}
	lastPoint = point;
}

function clear() {
	var c = document.getElementById("pointCanvas");
	var cxt = c.getContext("2d");
	c.height = c.height;
	lastPoint = {
		x: "0",
		y: "0",
		pressure: "0"
	};
	document.getElementById("picsign").src = "data:image/png;base64,";
}

/**
 * 初始化webSocket连接
 * @param callback
 * @param value
 * @constructor
 */
function ConnectServer(callback, value) {

	if ('WebSocket' in window) {
		websocket = new WebSocket(url);
	} else if (window.WebSocket) {
		websocket = new WebSocket(url);
	} else if ('MozWebSocket' in window) {
		websocket = new MozWebSocket(url);
	} else {
		alert("浏览器版本太低！请使用Chrome、Firefox、IE10+浏览器！");
	}

	websocket.onopen = function() {
		connected = true;
		callback(value);
	}
	websocket.onclose = function(e) {
		connected = false;
	}
	websocket.onmessage = function(e) {
		onMessage(e);
	}
	websocket.onerror = function(e) {
		alert("未连接websocket服务器，请确保已运行服务端！!!!")
	};

}

/**
 * 接收服务器消息
 * @param e
 */
function onMessage(e) {
	//console.log("onmessage::"+e.data)
	var jsonObj = eval('(' + e.data + ')');
	var result = JSON.parse(e.data);
	var ret = result.ret;
	var func = result.func;
	var pic = document.getElementById("picsign");
	if (func == "GetDeviceStatus") {
		//pic.src = "data:image/png;base64," + result.Base64;
		if ("0" === ret) {
			alert("设备正常")
		} else {
			alert("设备异常")
		}

	} else if (func == "GetDeviceInfo") {
		if ("0" === ret) {
			maxWidth = result["SignWidth"];
			maxHeight = result["SignHeight"];
			maxPressure= result["PressureLevel"];
			alert(JSON.stringify(result));
		} else {
			alert("获取失败")
		}
	} else if (func == "TouchInfo") {
		var data = result.info;
		if (data.length == 1 && data[0].btnId != "-1") {
			if(data[0].btnId != 3){
				clear();
			}
			
		} else {
			console.log("touchEvent:size=" + data.length);
			for (var i = 0; i < data.length; i++) {
				drawPoint(data[i]);
			}

		}
	}else if(func == "SignImgInfo"){
		console.log("SignImgInfo enter::"+result.data)
		pic.src = "data:image/png;base64," + result.data;
	}
}

/**
 * 向服务器发送信息的共享方法
 * @param jsonStr
 */
function sendMessage(jsonStr) {
	connected ? websocket.send(jsonStr) : alert("未连接websocket服务器，请确保已运行服务端！")
}


/******************* 以下为签名平板函数 *************************/

/**
 * 获取签字版状态
 * @constructor
 */
function GetDeviceStatus() {
	var data = JSON.stringify({
		'func': 'GetDeviceStatus'
	});
	connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}
//获取设备信息
function GetDeviceInfo() {
	var data = JSON.stringify({
		'func': 'GetDeviceInfo'
	});
	connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}

function SetCmdToDevice(flag) {
	clear();
	var data = JSON.stringify({
		'func': 'SetCmdToDevice',
		'flag': flag + ""
	});
	connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}
function startSign(pointType){
	clear();
	SetCmdToDevice(2);
	var data = JSON.stringify({
		'func': 'SetCmdToDevice',
		'flag': '1',
		'point_type':pointType + ""
	});
	connected ? sendMessage(data) : ConnectServer(sendMessage, data)
}
